#include "TestHaikuView.h"
//------------------------------------------------------------------------------
// BeOS
#include <File.h>
#include <Message.h>
#include <Resources.h>
// C++
#include <iostream>
// Add2
// Proj
#include "Constants.h"
//==============================================================================
TTestHaikuView::TTestHaikuView(BRect oFrame)
		: SUPER(oFrame, "TestHaikuView", B_FOLLOW_ALL, B_WILL_DRAW|B_FRAME_EVENTS)
{
	BRect			aFrame;
//	BMessageFilter*	aFilter;

	aFrame.Set(10, 10, 90, 32);
	mButtonTest = new BButton(aFrame, "ButtonTest", "Test", new BMessage(BUTTON_TEST_CLICKED));
	AddChild(mButtonTest);
	// 初期化
	mTest01ViewA = NULL;
	mTest01ButtonB = NULL;
}
//------------------------------------------------------------------------------
TTestHaikuView::~TTestHaikuView()
{
}
//------------------------------------------------------------------------------
void	TTestHaikuView::AttachedToWindow()
{
	mButtonTest->SetTarget(this);
}
//------------------------------------------------------------------------------
void	TTestHaikuView::ButtonTest01BClicked()
{
//	DBEXP("TTestHaikuView::ButtonTest01BClicked()", "");
}
//------------------------------------------------------------------------------
void	TTestHaikuView::ButtonTestClicked()
{
	Test02();
}
//------------------------------------------------------------------------------
void	TTestHaikuView::MessageReceived(BMessage* oMsg)
{
	switch ( oMsg->what ) {
	case BUTTON_TEST_01_B_CLICKED:
		ButtonTest01BClicked();
		break;
	case BUTTON_TEST_CLICKED:
		ButtonTestClicked();
		break;
	default:
		SUPER::MessageReceived(oMsg);
	}
}
//------------------------------------------------------------------------------
void	TTestHaikuView::MouseDown(BPoint oPoint)
{
//	DBEXP("TTestHaikuView::MouseDown()", BRect(oPoint, B_ORIGIN));
}
//------------------------------------------------------------------------------
void	TTestHaikuView::Test01()
{
	mTest01ViewA = new BView(BRect(10, 40, 100, 200), "Test01ViewA", B_FOLLOW_NONE, B_WILL_DRAW);
	mTest01ViewA->SetViewColor(255, 128, 128);
	AddChild(mTest01ViewA);
	mTest01ButtonB = new BButton(BRect(0, 0, 50, 50), "Test01ButtonB", "Invoke", new BMessage(BUTTON_TEST_01_B_CLICKED));
	mTest01ViewA->AddChild(mTest01ButtonB);
	mTest01ButtonB->SetTarget(this);
}
//------------------------------------------------------------------------------
void	TTestHaikuView::Test02()
{
	const char*	aBuf;
	size_t		aSize;
	BFile		aFile("/boot/home/Box.rsrc", B_READ_WRITE);
	BMessage	aArc;
	BResources	aRes;
	BView*		aView;

	cout << "res..." << endl;
	if ( aRes.SetTo(&aFile) != B_OK )
		return;
	cout << "load..." << endl;
	aBuf = reinterpret_cast<const char*>(aRes.LoadResource(B_ARCHIVED_OBJECT, static_cast<int32>(0), &aSize));
	if ( aBuf == NULL )
		return;
	cout << "unflat..." << endl;
	if ( aArc.Unflatten(aBuf) != B_OK )
		return;
	cout << "view..." << endl;
	aView = new BView(&aArc);
	aView->MoveTo(10, 50);
	AddChild(aView);
}
//------------------------------------------------------------------------------
//==============================================================================
